/***************************************************************************
 *   Copyright (C) 2007 by David Bitseff                                   *
 *   dbitsef@zipcon.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef EDITTRIANGLEWIDGET_H
#define EDITTRIANGLEWIDGET_H


#include "ui_edittrianglewidget.h"

class Triangle;
class FigureEditor;
class GenomeVector;

class EditTriangleWidget : public QWidget, private Ui::EditTriangleWidget
{
	Q_OBJECT

	private:
		QPointF triangleTransformPos();
		QPointF selectionTransformPos();

	public:
		EditTriangleWidget(GenomeVector*, FigureEditor*, QWidget* parent=0);

	signals:
		void dataChanged();

	public slots:
		void triangleSelectedSlot(Triangle* t);

	protected slots:
		void triangleScaledAction();
		void triangleRotatedAction();
		void triangleHFlippedAction();
		void triangleVFlippedAction();
		void sceneScaledAction();
		void toggleGridAction(bool);
		void gridColorSelectAction();
		void bgColorSelectAction();
		void showEvent(QShowEvent*);
		void moveTriangleLeftAction();
		void moveTriangleRightAction();
		void moveTriangleUpAction();
		void moveTriangleDownAction();
		void rotateTextEditedSlot();
		void scaleTextEditedSlot();
		void toggleMarkAction(bool);

	private:
		GenomeVector* genome;
		FigureEditor* editor;
		Triangle* selectedTriangle;
		double rotate_dx;
		double scale_dx;
};


#endif

