/***************************************************************************
 *   Copyright (C) 2007 by David Bitseff                                   *
 *   dbitsef@zipcon.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef VARSTABLEWIDGET_H
#define VARSTABLEWIDGET_H

#include <QTableWidget>
#include <QWheelEvent>

#define VARS_PRECISION 3

class VarsTableWidget : public QTableWidget
{
	Q_OBJECT

	public:
		VarsTableWidget(QWidget* parent=0);
		VarsTableWidget(int rows, int cols, QWidget* parent=0);
		void colorItem(QTableWidgetItem*, double);

	signals:
		void valueUpdated();

	protected:
		void mousePressEvent(QMouseEvent*);
		void keyPressEvent(QKeyEvent*);
		void wheelEvent(QWheelEvent*);

	private:
		QBrush activeColor;
		QBrush inactiveColor;
		double step;
};

#endif
